<script lang="ts">
import { MetaInfo } from 'vue-meta/types/vue-meta';
import Vue from 'vue';
import {
  Agenda,
  CityHero,
  ConductBanner,
  Decoration,
  WorldTourFormMulti,
} from '~/components/events/world-tour/index.vue';
import { NextStepAlt } from '~/components/common/index.vue';
import { getPageMetadata } from '~/common/meta';
import { FooterEditLinkMixin } from '~/mixins';
import { WorldTourEventsService } from '~/services';

export default Vue.extend({
  components: {
    CityHero,
    ConductBanner,
    NextStepAlt,
    WorldTourFormMulti,
    Agenda,
    Decoration,
  },
  mixins: [FooterEditLinkMixin],
  nuxtI18n: false,
  async asyncData({ params, $worldTourEventsService }: any) {
    try {
      const eventSlug = params.city;
      const { city, spaceId, entryId } = await (
        $worldTourEventsService as WorldTourEventsService
      ).getWorldTourEvent(`/executive/${eventSlug}`);

      return { city, spaceId, entryId };
    } catch (e) {
      throw new Error(e);
    }
  },

  head(): MetaInfo {
    return {
      meta: [{ hid: 'robots', name: 'robots', content: 'noindex' }],
      ...getPageMetadata((this as any).city.metadata, this.$route.path),
    };
  },
});
</script>

<template>
  <div>
    <CityHero
      v-if="city.hero"
      v-bind="city.hero"
      :registration-closed="city.form.registrationClosed"
      :location="city.location"
      :date="city.date"
    />
    <SlpContainer>
      <SlpRow>
        <SlpColumn :cols="6">
          <div
            class="city__description"
            v-html="$md.render(city.description)"
          ></div
        ></SlpColumn>
        <SlpColumn :cols="6"
          ><WorldTourFormMulti
            v-if="city.form && city.form.multiStepForm"
            v-bind="city.form"
          /> </SlpColumn></SlpRow
    ></SlpContainer>
    <Decoration />
    <Agenda v-if="city.agenda" v-bind="city.agenda" :location="city.location" />
    <div v-if="city.footnote">
      <ConductBanner
        v-for="footnote in city.footnote"
        :key="footnote.header"
        v-bind="footnote"
        class="city__section"
      />
    </div>
    <NextStepAlt />
  </div>
</template>

<style lang="scss" scoped>
.city {
  &__section {
    & + .city__section {
      padding-top: 0;
    }
  }
  &__description {
    :deep {
      h3 {
        font-size: 32px;
        line-height: 40px;
        font-weight: 400;
        letter-spacing: -1.2px;
        margin-bottom: 32px;
        font-weight: 600;
        @media (min-width: $breakpoint-md) {
          font-size: 40px;
          line-height: 48px;
          letter-spacing: -1.4px;
        }
      }
      p {
        font-size: 18px;
        font-style: normal;
        font-weight: 400;
        line-height: 28px;
        margin: 24px 0;
      }
      ul {
        padding-left: 32px;
        margin: 16px 0;

        li {
          margin-top: 8px;
          position: relative;

          &:before {
            content: url('/nuxt-images/icons/list-check-dark.svg');
            position: absolute;
            top: 3px;
            left: -30px;
          }
        }
      }
    }
  }
}
</style>
